<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref, computed, inject} from 'vue';
import { useI18n } from 'vue-i18n';
import { request } from '@/lib/request';
import { useMetaStore } from '@/stores/meta';
import Modal from '@/components/general/Modal.vue';
import Input from '@/components/general/form/Input.vue';
import { validFullMail } from '@/lib/utils';

const { t } = useI18n();
const $t = t; 

const store = useMetaStore();

let configuration = inject<any>('configuration');

const emits = defineEmits<{
    (e: "close", value:boolean):void,
}>();

const submitModal = async ()=>{
    try{
        let response = await request('POST', configuration.apiServer + '/api/account/password-reset-request'+ store.hashcode, 
            {mail: mail.value.toLowerCase() });
        if(response && response.success){
            showConfirmModal(true);
            
        }else{
            showError.value = true;
        }
    }catch(error){
        console.error(error);
        showError.value = true;
    }
    
}

const closeModal = ()=>{
    emits('close', false);
}
const mail = ref('');
const showError = ref(false);

const checkMail = computed(()=>{
    return validFullMail(mail.value);
})

const isConfirmModalOpen = ref(false);
const showConfirmModal = (value:boolean)=>{
    isConfirmModalOpen.value = value;
    if(!value)
        closeModal();
}


</script>
<template>
<div>
    <Modal :header="$t('general.variables.password.sg') + ' ' + $t('general.variables.reset')" 
        :labelCancel="$t('general.buttons.cancel')" 
        :labelSubmit="$t('general.buttons.send')" 
        :disableSubmit="!(mail && checkMail)"
        @submit="submitModal" @cancel="closeModal" @close="">
        <div class="mt-2">
            <p class="text-red-700" v-if="showError">{{$t('general.errors.unexpected')}}</p>
            <Input type="mail" size="w-full" v-model="mail" :label="$t('placeholder.mail')" :placeholder="$t('placeholder.mail')" :required="true" icon="mail" :autofocus="true"/>
        </div>
        <Modal v-if="isConfirmModalOpen" 
            :labelSubmit="$t('general.buttons.close')" 
            :text="$t('adminMenu.passwordReset.title')" 
            @submit="()=>showConfirmModal(false)"/>
    </Modal>
    
</div>
</template>